Description

The modular input keeps failing for some reason. arg.

Associated revisions

Revision 109 - 12/28/2014 05:10 AM - luke.murphey

Adding support for keep-alives for the TCP PLM connection. References

#913.

Revision 110 - 12/28/2014 05:13 AM - luke.murphey

Adding select.select to detect connection failures. Reference #913.

History

#1 - 11/24/2014 05:47 PM - Luke Murphey

No relevant logs. The input just seems to stop. The connection to the hub appears down too.

#2 - 11/24/2014 05:55 PM - Luke Murphey

Theories:

1. The socket times out due to no activity

I might be able to handle with a TCP keep alive. I would expect that an exception would have been generated though.

2. An exception is being generated but not handled

I would think that the exception would be outputted.

3. The input is in a infinite loop

CPU usage seems fine though.

#3 - 11/24/2014 05:56 PM - Luke Murphey

- Status changed from New to In Progress

#4 - 11/24/2014 07:04 PM - Luke Murphey

- Priority changed from Normal to Urgent

#5 - 11/26/2014 03:24 AM - Luke Murphey

I suspect the issue is in the TCP interface read function that swallows socket exceptions.
http://delog.wordpress.com/2013/08/16/handling-tcp-keepalive/


#6 - 11/26/2014 04:17 AM - Luke Murphey

- % Done changed from 0 to 90

#7 - 11/26/2014 05:54 PM - Luke Murphey

- Status changed from In Progress to Closed

- % Done changed from 90 to 100

#8 - 12/27/2014 11:08 PM - Luke Murphey

- Status changed from Closed to In Progress

#9 - 12/27/2014 11:08 PM - Luke Murphey

Still happens.

#10 - 12/27/2014 11:09 PM - Luke Murphey

Trying this method to detect down sockets: http://stackoverflow.com/questions/17386487/python-detect-when-a-socket-disconnects-for-any-reason

#11 - 12/27/2014 11:12 PM - Luke Murphey

http://stackoverflow.com/questions/667640/how-to-tell-if-a-connection-is-dead-in-python

#12 - 12/27/2014 11:27 PM - Luke Murphey

2014-12-27 17:12:03,006 ERROR Execution failed: Traceback (most recent call last):

  File "/Library/Splunk/splunk_sp/etc/apps/insteon/bin/insteon_app/modular_input.py", line 1127, in execute

    self.do_run(in_stream, log_exception_and_continue=True)

  File "/Library/Splunk/splunk_sp/etc/apps/insteon/bin/insteon_app/modular_input.py", line 1027, in do_run

    input_config)

  File "/Library/Splunk/splunk_sp/etc/apps/insteon/bin/insteon_plm.py", line 189, in run

    ready_to_read, ready_to_write, in_error = select.select([self.interface.__s,], [self.interface.__s,], [], 

5)

AttributeError: 'TCP' object has no attribute '_InsteonPLMInput__s'

#13 - 12/27/2014 11:28 PM - Luke Murphey

Monitoring the connection with this:

netstat -n | grep 9761

#14 - 12/27/2014 11:38 PM - Luke Murphey

To test, I disconnected from the network for several minutes. I see that a connection is still established but no packets are being sent back and forth.

It seems like the connection is broken from the hub-side and isn't being detected by Python.

Re-establishing a connection from another hosts succeeds which indicates that the connection really was dead. I'm going to leave the input running to

see if it eventually detects the connection failure using the select.select method.
#15 - 12/28/2014 04:06 AM - Luke Murphey

It's been 4 hours and my host still shows a connection to the PLM. I'm going to look into using a keep alive to help detect connection failures.

#16 - 12/28/2014 04:11 AM - Luke Murphey

http://stackoverflow.com/questions/12248132/how-to-change-tcp-keepalive-timer-using-python-script

#17 - 12/28/2014 04:12 AM - Luke Murphey

https://delog.wordpress.com/2013/08/16/handling-tcp-keepalive/

#18 - 01/05/2015 05:42 PM - Luke Murphey

- % Done changed from 100 to 80

#19 - 01/05/2015 06:07 PM - Luke Murphey

Implemented a method that bounces the connection if no activity is observed within a given time frame.

#20 - 01/05/2015 06:07 PM - Luke Murphey

- % Done changed from 80 to 100

#21 - 01/07/2015 10:57 PM - Luke Murphey

- Status changed from In Progress to Closed
